/*********************************************************************/
/* Copyright (C) 1995, Nikos P. Chrisochoides                        */
/*                     Norhteast Parallel Architectures Center       */
/*                     e-mail:  nikos@npac.syr.edu                   */
/*                     phone :  (315) 443 3794                       */
/*                       All Rights Reserved                         */
/*                                                                   */
/*                                                                   */
/* Redistribution and use in source and binary forms are permitted   */
/* provided that this entire copyright notice is duplicated in all   */ 
/* such copies.  No charge, other than an "at-cost" distribution fee,*/ 
/* may be charged for copies, derivations, or distributions of this  */ 
/* material without the express written consent of the copyright.    */
/* holders. Neither the name of the University, nor the name of the  */
/* authors may be used to endorse or promote products derived from   */
/* this material without specific prior written permission.          */
/*                                                                   */
/* THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR    */
/* IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED    */
/* WARRANTIES OIMPLIED MERCHANTIBILITY AND FITNESS FOR ANY PARTICULAR*/
/* PURPOSE.                                                          */
/*********************************************************************/
#include "pamrsl_cluster.h"

int
RegionAccepted3D(cells, n1, n2, n3, ia, ib, ja, jb, ka, kb)
     int *cells;
     int n1, n2, n3, ia, ib, ja, jb, ka, kb;
{
  register int ic;
  int i, j, k,id, ii, *cellstemp;
  int jj,kk,ll;
  int number, count=0;
  float percent;
  int status;
/*  printf("RegionAccepted3D entered");
    printf("%d %d %d", n1,n2,n3);
 ll=0;
 for(ii=0; ii< n1; ii++) {
    for(jj=0; jj<n2 ; jj++){  
       for(kk=0; kk<n3;kk++) {
          printf("%d", cells[ll]);
          ll++;
        }
     }
  }  

  printf("%d", ll);
  printf("done printing");*/
/*  printf("\n ib etc %d %d %d %d %d %d ", ia, ib, ja, jb, ka, kb); */
  number = (ib-ia+1) * (jb-ja+1) * (kb-ka+1); 
/*  printf("number= %d", number); */
  for (ic=0, i=ia; i < ib+1; i++)
    for (j=ja; j < jb+1; j++)
      for (k=ka; k < kb+1; k++)
	{
         /* printf("id before callin mapping %d", id);*/
	  id = mapping3d_(&n2, &n3, &i, &j, &k);
        /*  printf("id in RegionAccepted3D %d", id);*/
/*          printf("id = %d, cells[id]= %d", id, cells[id]); */
	  if (cells[id] == 1)
	    count++;
	}
  if (count == 0)
	{
		status = 0;
		return status;
    }
  percent = (float) count / (float) number;
 
  printf("percent= %f packingtol= %f count= %d \n", percent, PACKINGTOL, count);
  printf("   number = %f \n",number);

  if ((ia == ib || ja == jb || ka == kb) && count != 0) 
    {
	 status = 1;
     return status;    
    }

  if (percent > PACKINGTOL)
    {
	 status = 1;
     return TRUE;
  }
  else{
    status = -1;
printf("MM:RegionAccepted3d:returning -1 due to packingtol \n");
printf("MM:RegionAccepted3d: percent = %25.16e \n",percent);
    return FALSE;
  }
}


void
GroupRegions3D(index, ia, ib, ja, jb, ka, kb, n1, n2, n3, lptr, level, cells)
     int *index, n1, n2, n3, ia, ib, ja, jb, ka, kb, level;
     ListPtr *lptr;
     int *cells;
{
  register int ic;
  int i, j, k, id;
  int Imid, Jmid, Kmid;
  int Isize, Jsize, Ksize, max;
  GridCompPtr gcomp;
  int status;
  
   
  if ((status = RegionAccepted3D(cells, n1, n2, n3, ia, ib, ja, jb, ka, kb)) == 1)
    {
      gcomp = (GridComp *) malloc(sizeof(GridComp));
      gcomp->id = (*index)++;
      gcomp->clst = (Cluster *) malloc(sizeof(Cluster));
      gcomp->clst->ncells = (ib-ia+1) * (jb-ja+1) * (kb-ka+1); 
      gcomp->clst->tabcells = (int *) 
	calloc(gcomp->clst->ncells, sizeof(int *));
      for (ic=0, i=ia; i < ib+1; i++)
	for (j=ja; j < jb+1; j++)
	  for (k=ka; k < kb+1; k++)
	    {
	      id = mapping3d_(&n2, &n3, &i, &j, &k);
	      gcomp->clst->tabcells[ic++] = cells[id];
	    }
      gcomp->clst->ia = ia; gcomp->clst->ib = ib;
      gcomp->clst->ja = ja; gcomp->clst->jb = jb;
      gcomp->clst->ka = ka; gcomp->clst->kb = kb;
      gcomp->clst->nneighbors = 0;
      gcomp->clst->boundary = -1; 

      LInsertComponent(lptr, (char *) gcomp);
    }
  else  
    if ((status == -1) && (ia != ib || ja != jb || ka != kb))
      {
	Isize = jb - ja;
	Jsize = ib - ia;
	Ksize = kb - ka;
	if (Isize == MAX3(Isize, Jsize, Ksize))
	  {
	    Imid = (ib + ia)/2;
	    GroupRegions3D(index, ia, Imid, ja, jb, ka, kb, n1, n2,
			   n3, lptr, level, cells);
	    GroupRegions3D(index, Imid+1, ib, ja, jb, ka, kb, n1, n2,
			   n3, lptr, level, cells);
	  }
	else
	  if (Jsize == MAX3(Isize, Jsize, Ksize))
	    {		 
	      Jmid = (jb + ja)/2;
	      GroupRegions3D(index, ia, ib, ja, Jmid, ka, kb, n1, n2,
			     n3, lptr, level, cells);
		 GroupRegions3D(index, ia, ib, Jmid+1, jb, ka, kb, n1, n2,
				n3, lptr, level, cells);
	    }
	  else
	    {
	      Kmid = (kb + ka)/2;
	      GroupRegions3D(index, ia, ib, ja, jb, ka, Kmid, n1, n2,
			     n3, lptr, level, cells);
	      GroupRegions3D(index, ia, ib, ja, jb, Kmid+1, kb, n1, n2,
			     n3, lptr, level, cells);
	    }
      }
	else
	{
	  printf("Region [%d, %d]x[%d, %d]x[%d, %d] can't be a cluster\n", 	
				ia, ib, ja, jb, ka, kb); 
	}
}

	    
int
RegionAccepted2D(cells, n1, n2, ia, ib, ja, jb)
     int *cells;
     int n1, n2, ia, ib, ja, jb;
{
  register int ic;
  int i, j, id;
  int number, count=0;
  float percent;
  
  number = (ib-ia+1) * (jb-ja+1); 
  for (ic=0, i=ia; i < ib+1; i++)
    for (j=ja; j < jb+1; j++)
      {
	(void) mapping2d_(&n2, &i, &j, &id);
	if (cells[id] == 1)
	  count++;
      }
  percent = (float) count / (float) number;
  
  if ((ia == ib || ja == jb) && count != 0) 
    return TRUE;    

  if (percent > PACKINGTOL)
    return TRUE;
  else
    return FALSE;
} 

void
GroupRegions2D(index, ia, ib, ja, jb, n1, n2, lptr, level, cells)
     int *index, n1, n2, ia, ib, ja, jb, level;
     ListPtr *lptr;
     int *cells;
{
  register int ic;
  int i, j, id;
  int width, height;
  int Imid, Jmid;
  GridCompPtr gcomp;

  if (RegionAccepted2D(cells, n1, n2, ia, ib, ja, jb) == TRUE)
    {
      gcomp = (GridComp *) malloc(sizeof(GridComp));
      gcomp->id = (*index)++;
      gcomp->clst = (Cluster *) malloc(sizeof(Cluster));
      gcomp->clst->ncells = (ib-ia+1) * (jb-ja+1); 
      gcomp->clst->tabcells = (int *) 
	calloc(gcomp->clst->ncells, sizeof(int));
      for (ic=0, i=ia; i < ib+1; i++)
	for (j=ja; j < jb+1; j++)
	  {
	    (void) mapping2d_(&n2, &i, &j, &id);
	    gcomp->clst->tabcells[ic++] = cells[id];
	  }
      gcomp->clst->ia = ia;
      gcomp->clst->ib = ib;
      gcomp->clst->ja = ja;
      gcomp->clst->jb = jb;
      gcomp->clst->nneighbors = 0;
      gcomp->clst->boundary = -1; 

      LInsertComponent(lptr, (char *) gcomp);
    }
  else
    if (ia != ib || ja != jb)
      {
	width = jb - ja;
	height = ib - ia;
	if (width <= height)
	  {
	    Imid = (ib + ia)/2;
	    GroupRegions2D(index, ia, Imid, ja, jb, n1, n2, lptr,
			   level, cells);
	    GroupRegions2D(index, Imid+1, ib, ja, jb, n1, n2, lptr,
			   level, cells);
	  }
	else
	  {
	    Jmid = (jb + ja)/2;
	    GroupRegions2D(index, ia, ib, ja, Jmid, n1, n2, lptr,
			   level, cells);
	    GroupRegions2D(index, ia, ib, Jmid+1, jb, n1, n2, lptr,
			   level, cells);
	  }
      }
}


void
cluster(dim, n1, n2, n3, cells, npatches, patches, level)
     int dim, n1, n2, n3, *cells, *npatches, *patches, level;
{
  int i, itmp, jtmp, ktmp;
  register int istart, jstart, kstart, iend, jend, kend;
  int id;
  ListPtr lptr, comp;
  GridCompPtr gcomp;
  ClusterPtr cl;
  int ncells,ii,jj,kk,ll; 
  double t1;
/*  extern int my_sec();*/

/*  t1 = (float) my_sec();*/

/* printf("dim= %d, n1= %d, n2= %d, n3= %d, level= %d \n", dim,n1, n2, n3,level); */
  
 ll=0;
/* for (ii=0; ii< n1; ii++) {
    for(jj=0; jj<n2 ; jj++) { 
       for(kk=0; kk<n3;kk++) {
          printf("%d", cells[ll]);
          ll++;
        }
     }
  }
*/
/*  printf("%d \n ", ll);
 for(ii=0;ii<=20;ii+=5) { 

 printf("%d %d %d %d %d \n" ,cells[ii],cells[ii+1],cells[ii+2],cells[ii+3], 
        cells[ii+4]); 
}
 printf("\n");

 for(ii=25;ii<=45;ii+=5) { 

 printf("%d %d %d %d %d \n" ,cells[ii],cells[ii+1],cells[ii+2],cells[ii+3], 
        cells[ii+4]);
}
 printf("\n");

 for(ii=50;ii<=70;ii+=5) { 

 printf("%d %d %d %d %d \n" ,cells[ii],cells[ii+1],cells[ii+2],cells[ii+3], 
        cells[ii+4]);
}
 printf("\n");

 for(ii=75;ii<=95;ii+=5) { 

 printf("%d %d %d %d %d \n" ,cells[ii],cells[ii+1],cells[ii+2],cells[ii+3], 
        cells[ii+4]);
}
 printf("\n");
 for(ii=100;ii<=120;ii+=5) { 

 printf("%d %d %d %d %d \n" ,cells[ii],cells[ii+1],cells[ii+2],cells[ii+3], 
        cells[ii+4]);
}
 printf("\n");
  printf("\n Cluster entered \n");  */


  switch (dim) /* Compute Initial Region */
    {
    case 2:
      ncells = n1 * n2;
      istart = jstart = MAX(n1, n2);
      iend = jend = 0;
      for (i=0; i < ncells; i++)
	{
	  if (cells[i] == 1) /* cell==1 indicates that it is marked */
	    {
	      (void ) invmapping2d_(&i, &n2, &itmp, &jtmp);
      
	      istart = MIN(istart, itmp);
	      jstart = MIN(jstart, jtmp);

	      iend = MAX(iend, itmp);
	      jend = MAX(jend, jtmp);
	    }
	}
      break;
    case 3:
      ncells = n1 * n2 * n3;
      istart = jstart = kstart = MAX3(n1, n2, n3);
      iend = jend = kend = 0;
      for (i=0; i < ncells; i++)
	{
	  if (cells[i] == 1)
	    {
	      (void) invmapping3d_(&i, &n1, &n2, &itmp, &jtmp, &ktmp);
      
	      istart = MIN(istart, itmp);
	      jstart = MIN(jstart, jtmp);
	      kstart = MIN(kstart, ktmp);

	      iend = MAX(iend, itmp);
	      jend = MAX(jend, jtmp);
	      kend = MAX(kend, ktmp);
	    }

	}
/* printf("******************"); */
/* printf("istart= %d %d %d %d %d %d", istart, iend, jstart, jend, kstart, kend); */
      break;
    }
  
  /* Recursively bisect initial region:  
   *            <istart, iend> x <jstart, jend> x <kstart, kend>
   *  until certain criteria are optimized; save clusters into a list.
   */
  id = 0;
  InitList(&lptr);
  switch (dim) /* Compute Patches */
    {
    case 2:
      (void) GroupRegions2D(&id, istart, iend, jstart, jend, 
			    n1, n2, &lptr, level, cells); 
      break;
    case 3:
      (void) GroupRegions3D(&id, istart, iend, jstart, jend, 
			    kstart, kend, n1, n2, n3, &lptr, level, cells); 
      break;
    }
  
  /* Traverse List : 1. compute number of newly created patches
   *               : 2. store them in the array "patches"
   */
/* Next statement added by Tejas for debugging */
/*  printf("modifying npatches=  %d \n", (*npatches));
  if(comp) printf("Comp not Null");
  else printf("Comp NULL \n"); */
  for (comp = lptr; comp != NULL; comp = NEXT(comp)) {
/* Next statement added by Tejas for debugging */
/*  printf("modifying npatches=  %d \n", (*npatches)); */
    (*npatches)++;
}
  switch (dim) /* Compute Patches */
    {
    case 2:
      for (i=0, comp = lptr; comp != NULL; comp = NEXT(comp))
	 {
	   gcomp = (GridCompPtr) DATA(comp);
	   cl = gcomp->clst;
	   patches[i] = cl->ia;
	   patches[i+1] = cl->ja;
	   patches[i+2] = (cl->ib) - (cl->ia);
	   patches[i+3] = (cl->jb) - (cl->ja);
	   i = i + 4;
	 }
      break;
    case 3:
/*      patches = (int *) calloc(6*(*npatches), sizeof(int)); */
      for (i=0, comp = lptr; comp != NULL; comp = NEXT(comp))
	 {
	   gcomp = (GridCompPtr) DATA(comp);
	   cl = gcomp->clst;
	   patches[i] = cl->ia;
	   patches[i+1] = cl->ja;
	   patches[i+2] = cl->ka;
	   patches[i+3] = (cl->ib) - (cl->ia);
	   patches[i+4] = (cl->jb) - (cl->ja);
	   patches[i+5] = (cl->kb) - (cl->ka);
	   i = i + 6;
	 }	   
      break;
    }
/*    printf("patches in C");
   
    for(i=0;i<20;i++) printf("%d ",patches[i]); */

/*  printf("Time for the Clustering  (in sec) %f \n", (float) 
		     (my_sec()-t1)/60.0);*/
}












